package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.Pacote;
import com.rjconsultores.ventaboletos.entidad.PacoteTarifa;
import com.rjconsultores.ventaboletos.entidad.TipoTarifaPacote;
import com.rjconsultores.ventaboletos.service.PacoteTarifaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;

@Controller("editarPacoteTarifaController")
@Scope("prototype")
public class EditarPacoteTarifaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(EditarPacoteTarifaController.class);

	@Autowired
	private PacoteTarifaService pacoteTarifaService;

	private Pacote pacote;
	private TipoTarifaPacote tipoTarifaPacote;
	private MyListbox tarifaPacoteList;
	private MyTextbox txtDescTarifa;
	private MyTextboxDecimal tarifa;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		pacote = (Pacote) Executions.getCurrent().getArg().get("pacote");
		tipoTarifaPacote = (TipoTarifaPacote) Executions.getCurrent().getArg().get("tipoTarifaPacote");
		tarifaPacoteList = (MyListbox) Executions.getCurrent().getArg().get("tarifaPacoteList");

		if (tipoTarifaPacote != null) {
			txtDescTarifa.setValue(tipoTarifaPacote.getDesctipotarifa());
		}
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {

		try {
			tipoTarifaPacote.setDesctipotarifa(txtDescTarifa.getValue());
			PacoteTarifa pacoteTarifa = pacoteTarifaService.vincularPacoteTarifa(null, pacote, tipoTarifaPacote,
					tarifa.getValueDecimal());
			tarifaPacoteList.addItemNovo(pacoteTarifa);

			closeWindow();

		} catch (WrongValueException ex) {
			throw (WrongValueException) ex;
		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(Labels.getLabel("MSG.Error").concat(" - ").concat(ex.toString()),
					Labels.getLabel("editarConfiguracionPacoteController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}
}
